<?php

namespace Drupal\feeds_filemaker\Feeds\Fetcher\Form;

use Drupal\Core\Form\FormStateInterface;
use Drupal\feeds\Feeds\Fetcher\Form\HttpFetcherForm;

class FileMakerApiFetcherForm extends HttpFetcherForm {

  /**
   * {@inheritdoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    $form = parent::buildConfigurationForm($form, $form_state);

    $form['batch_size'] = [
      '#type' => 'number',
      '#title' => $this->t('Batch Size'),
      '#description' => $this->t('The number of items to fetch in each API request.'),
      '#default_value' => $this->plugin->getConfiguration('batch_size'),
      '#min' => 1,
      '#max' => 1000,
      '#required' => TRUE,
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function validateConfigurationForm(array &$form, FormStateInterface $form_state) {
    parent::validateConfigurationForm($form, $form_state);

    $batch_size = $form_state->getValue('batch_size');
    if ($batch_size < 1 || $batch_size > 1000) {
      $form_state->setErrorByName('batch_size', $this->t('Batch size must be between 1 and 1000.'));
    }
  }
}
